// dateParse.cs
using System;
using System.Globalization;
using System.Text.RegularExpressions;

namespace x10d.HidemaruMacro {
///<example>
///̃NX̎gB
///</example>
///<code>
///using x10d.HidemaruMacro;
///class SampleOfStringToDateTime {
///	static void Main () {
///		string[] ary1 = {"", "5 ", "05 ", "15 ", "215 ", "205 ", "0215 ", "1215 ", "90205 ", "090205 ", "091215 "};
///		string[] ary2 = {"", "21:", "21:34"};
///		foreach(string h in ary2) {
///			foreach(string d in ary1) {
///				Console.Write(d + "\t" + h + " =\t");
///				Console.WriteLine(new StringToDateTime(d + h).dateTime.ToString("s"));
///			}
///		}
///	}
///}
///</code>
	public class StringToDateTime {
		readonly public DateTime dateTime;

		public StringToDateTime() {
			dateTime = DateTime.Now;
		}

		public StringToDateTime(string dtstr) {
		//TODO: jBBɂ25thƂ悤ɎwłB
		/*
			Su(nday)	jB擪2Bł\BN̎wƓɂłȂB
			[12]?(1st|2nd|3rd|\dth)	ɂBN̎wƓɂłȂB
			5/$		Bp[XO28ɒuBm肵炻̌̌ɈړB
			+/-vZ||LuʂɃp[XɈړ<>@𔽉f
		*/
			DateTime       dt  = new DateTime ();
			CultureInfo    ci  = new CultureInfo("", true);
			DateTimeStyles dts = (DateTimeStyles.AllowTrailingWhite
			                   |  DateTimeStyles.NoCurrentDateDefault);
			try {
				// ((yy)yy/)MM/ddA12:34(:56)Aт̑gݍ킹ABNw肳ĂȂꍇ͍NBɂw肳ĂȂꍇ͐1NUB
				dt = DateTime.Parse(dtstr, ci, dts);

			} catch (FormatException) {
				dt = ParseString(dtstr, ci, dts);
			} finally {
				// _ɍł߂ɕύXB
				DateTime today = DateTime.Today;
				if(dt.Year < 1000) {
					if(dt.Month == 1) {
						if(dt.Day == 1) {
							dt = today.Date + dt.TimeOfDay;
						} else {
							dt = dt.AddYears((dt.Year == 1 ? today.Year - 1 : 2000)).AddMonths(today.Month - 1);
						}
					} else {
						dt = dt.AddYears((dt.Year == 1 ? today.Year - 1 : 2000));
					}
				} else {
					if(dt.Month == 1 && today.Month != 1) {
						dt = dt.AddMonths(today.Month - 1);
					}
				}
				/*
				>		́B_V
				<		ÓB_Â
				@		߂́B_VƌÂƂrāAԓIɋ߂̓
				+/	_w肳ꂽԂZB+1̑+ł\
				-/	_w肳ꂽԂZB-1̑-ł\
				:
				+1 15:	15B
				+1 +15:	̓15ԌB
				+1 @15:	̓ł߂15B
				+sun
				*/
			}
			this.dateTime = dt;
		}

		private DateTime ParseString(string dtstr, CultureInfo ci, DateTimeStyles dts) {

			if(dtstr == "")	return DateTime.Now;		// ̍sȂꍇA00ԂB

			DateTime dt = new DateTime ();
			try {
				try {
					// XbVnCtȂꍇAtŎԂw肳ĂȂƂ̂ݐBw肳ĂȂꍇ͍N1BNw肳ĂȂꍇ͍NB
					string[] candidates = {"d", "dd", "Mdd", "MMdd", "yMMdd", "yyMMdd", "M/d", "MM/d", "M/dd", "MM/dd", "M-d", "MM-d", "M-dd", "MM-dd", "h:00", "hh:00"};
					dt = DateTime.ParseExact(dtstr, candidates, ci, dts);
				} catch (FormatException) {
					Match m = Regex.Match(dtstr, @"(?(\d+:)|(((?<y>\d{1,4}[-/]?)(?<M>\d{2}[-/]?)(?<d>\d{2}))|((?<M>\d{1,2}[-/]?)(?<d>\d{2}))|(?<d>\d{1,2}))?)\s*((?<h>(?<!\d+)\d{1,2}(?=:)):(?<m>\d{1,2})?)?");
					if(m.Success){
						dt = new DateTime(
						           (m.Groups["y"].Success ?
						            //Convert.ToInt32(m.Groups["y"].Value.PadLeft(3, '0').PadLeft(4, '2')) :
						            Convert.ToInt32(m.Groups["y"].Value) :
						            1),
						           (m.Groups["M"].Success ? Convert.ToInt32(m.Groups["M"].Value) : 1),
						           (m.Groups["d"].Success ? Convert.ToInt32(m.Groups["d"].Value) : 1),
						           (m.Groups["h"].Success ? Convert.ToInt32(m.Groups["h"].Value) : 0),
						           (m.Groups["m"].Success ? Convert.ToInt32(m.Groups["m"].Value) : 0),
						           0);
						/* ǂBꉞParsecƂB
						dt = DateTime.Parse((m.Groups["y"].Success ? m.Groups["y"].Value : "0001")
						                + "/" + (m.Groups["M"].Success ? m.Groups["M"].Value : "1")
						                + "/" + (m.Groups["d"].Success ? m.Groups["d"].Value : "1")
						                + " " + (m.Groups["h"].Success ? m.Groups["h"].Value : "0")
						                + ":" + (m.Groups["m"].Success ? m.Groups["m"].Value : "0"),
						                new CultureInfo("ja-JP", true),
						                DateTimeStyles.AllowTrailingWhite | DateTimeStyles.NoCurrentDateDefault);
						*/
					}
				}
			} catch {
				dt = DateTime.Now;
			}
			return dt;
		}
	}
}
